#!/bin/bash
# setup script
# 

if [[ $0 != "./setup.sh" ]]
	then echo "Please run this script using \"./setup.sh\" from within the setup directory."; exit;
fi

echo -e "This script is intended for new installs.  If you\nare _upgrading_, please use the \"upgrade.sh\" script."
read -p "Continue? [Y/n] " CONTINUE
if [[ $CONTINUE = "n" ]] || [[ $CONTINUE = "N" ]]
	then echo "Exiting."; exit
	
else
	if [[ $CONTINUE = "y" ]] || [[ $CONTINUE = "Y" ]] || [[ $CONTINUE = "" ]]
		then echo -e "\n"
	else exit
	fi
fi


username=`whoami`
echo -e "+++++++Getting MySQLdb interaction information+++++++\n(default in [brackets]\n"

while [[ $SQLAUTHSUCCESS != "1" ]]; do

	# sqlhost processing
	read -p "MySQL Hostname (usually localhost): [localhost] " sqlhost
	if [[ $sqlhost = "" ]]; then sqlhost="localhost"; fi

	#sqldbname processing
	read -p "MySQL Database Name: " sqldb
	
	#sqluser processing
	read -p "MySQL User: [$username] " sqluser
	if [[ $sqluser = "" ]]; then sqluser="$username"; fi
	
	#sqlpass processing
	read -s -p "MySQL Password: " sqlpass
	echo ""
	
	sqlout=`mysql --user=$sqluser --password=$sqlpass --database=$sqldb --host=$sqlhost --execute= 2>&1`

	if [[ $? -eq 0 ]]
		then SQLAUTHSUCCESS="1"
	else
		sqlout=${sqlout:6:4}
		if [[ $sqlout = "1049" ]]
			then echo -e "Invalid databasename: ${sqldb}, try again.\n"
		fi
		if [[ $sqlout = "1045" ]]
			then echo -e "Bad Username/Password, try again.\n"
		fi
		if [[ $sqlout = "2005" ]]
			then echo -e "Unknown host: $sqlhost\n"
		fi
				
	fi
done

echo -e "\n\nThe table prefix default is \"discloser_\", which would create tables \nnamed \"discloser_posts\" and \"discloser_users\".  This is a good idea \nto change if you want multiple installs of discloser \nin one database.\n"
read -p "Specify table name prefix: [discloser_] " tableprefix
if [[ $tableprefix = "" ]]; then tableprefix="discloser_"; fi

createtableposts="CREATE TABLE ${tableprefix}posts (id int(11) NOT NULL auto_increment, type varchar(50) default NULL, subject tinytext, poster tinytext, posttime datetime default NULL, edittime datetime default NULL, content text, longcontent longtext, PRIMARY KEY (id)) TYPE=MyISAM"
createtableusers="CREATE TABLE ${tableprefix}users (id INT(11) NOT NULL AUTO_INCREMENT, username tinytext, password tinyblob NOT NULL, admin tinyint(1) default '0', num_display int(11) default '10', email tinyblob, PRIMARY KEY(id)) TYPE=MyISAM"
droptables="DROP TABLES ${tableprefixusers}posts, ${tableprefix}users"

read -p "This will overwrite tables named ${tableprefix}posts and ${tableprefix}users..  Continue? [Y/n] "
if [[ $CONTINUE = "n" ]] || [[ $CONTINUE = "N" ]]
	then echo "Exiting."; exit
	
else
	if [[ $CONTINUE = "y" ]] || [[ $CONTINUE = "Y" ]] || [[ $CONTINUE = "" ]]
		then echo -e "\n"
	else exit
	fi
fi


sqlout=`mysql --user=$sqluser --password=$sqlpass --database=$sqldb --host=$sqlhost --execute="$droptables" 2>&1`
sqlout=`mysql --user=$sqluser --password=$sqlpass --database=$sqldb --host=$sqlhost --execute="$createtableposts" 2>&1`
sqlout=`mysql --user=$sqluser --password=$sqlpass --database=$sqldb --host=$sqlhost --execute="$createtableusers" 2>&1`

read -p "We need to create an admin user.  Username: " adminusername
until [[ $passmatch = 1 ]]
do
	read -s -p "Password: " adminpass1
	read -s -p "Again: " adminpass2
	if [[ $adminpass1 == $adminpass2 ]]; then
		passmatch=1
		adminpassword=$adminpass1
	else
		echo "Does not match."
	fi
done
addadminuser="INSERT INTO ${tableprefix}users (username, password, admin) VALUES ('${adminusername}', MD5('${adminpassword}'), 1)"
sqlout=`mysql --user=$sqluser --password=$sqlpass --database=$sqldb --host=$sqlhost --execute="$addadminuser" 2>&1`

cat >../inc/vars.php<<zzendofcatzz
<?

/*
*  NAME
*	vars.php - Variables use throughout the site.  Human-edittable.
*
*/

// mysql host (usually localhost)
\$mysqlhost = "$sqlhost";

// mysql username
\$mysqluser = "$sqluser";

// mysql password
\$mysqlpass = "$sqlpass";

// mysql database name
\$mysqldb = "$sqldb";

// To specify a prefix for the table names
// (example "discloser_" would make the
// tables named discloser_users and discloser_posts
\$tableprefix = "$tableprefix";

\$use_bbcode = "no"; // yes or no
\$allow_html = "no"; // yes or no (only used if bbcode is not.)
\$print_date_once = "yes";  // yes or no
\$public_page_url = "/index.php"; // a convenience.  nothing serious will break if this is wrong.

// the contents of an "a href=" used to contact an admin.
\$administrative_contact = "mailto:webmaster@domain.com";

// uncomment below and set, if you need it
#\$session_file_storage_location = "/tmp";
	/*	this is a security measure to prevent session faking.. this only needs to be
		set if discloser is in a server environment where a malicious user can create
		a session for the same domain. (if this is in a public_html directory, not on
		a virtual host, where there may exist other users that cannot necessarily be
		trusted.)  It can also be used if the server is distributed, and doesn't share
		/tmp directories.  A common value would be "/home/user/tmp" where the webserver
		has read/write access. */


// will be depreciated before v.0.5
\$num_displayed_for_edit = "50";


?>
zzendofcatzz

echo "All done.  Go to admin.php in a webbrowser to make sure everything went smoothly and you can log in..  then move index.php and indexvars.php to whereever you want the public page, and edit indexvars.php according to the comments."
