#!/bin/bash
# setup script
# 

if [[ $0 != "./upgrade.sh" ]]
	then echo "Please run this script using \"./upgrade.sh\" from within the setup directory."; exit;
fi

echo -e "This is the upgrade script.  It is intended for use when you have a previous installation of Discloser, where you wish to keep the databases intact.  All this will do is generate a vars.php file."
read -p "Continue? [Y/n] " CONTINUE
if [[ $CONTINUE = "n" ]] || [[ $CONTINUE = "N" ]]
	then echo "Exiting."; exit
	
else
	if [[ $CONTINUE = "y" ]] || [[ $CONTINUE = "Y" ]] || [[ $CONTINUE = "" ]]
		then echo -e "\n"
	else exit
	fi
fi


username=`whoami`
echo -e "+++++++Getting MySQLdb interaction information+++++++\n(default in [brackets]\n"

while [[ $SQLAUTHSUCCESS != "1" ]]; do

	# sqlhost processing
	read -p "MySQL Hostname (usually localhost): [localhost] " sqlhost
	if [[ $sqlhost = "" ]]; then sqlhost="localhost"; fi

	#sqldbname processing
	read -p "MySQL Database Name: " sqldb
	
	#sqluser processing
	read -p "MySQL User: [$username] " sqluser
	if [[ $sqluser = "" ]]; then sqluser="$username"; fi
	
	#sqlpass processing
	read -s -p "MySQL Password: " sqlpass
	echo ""
	
	sqlout=`mysql --user=$sqluser --password=$sqlpass --database=$sqldb --host=$sqlhost --execute= 2>&1`

	if [[ $? -eq 0 ]]
		then SQLAUTHSUCCESS="1"
	else
		sqlout=${sqlout:6:4}
		if [[ $sqlout = "1049" ]]
			then echo -e "Invalid databasename: ${sqldb}, try again.\n"
		fi
		if [[ $sqlout = "1045" ]]
			then echo -e "Bad Username/Password, try again.\n"
		fi
		if [[ $sqlout = "2005" ]]
			then echo -e "Unknown host: $sqlhost\n"
		fi
				
	fi
done

echo -e "\n\nThe table prefix default is \"discloser_\", which would create tables \nnamed \"discloser_posts\" and \"discloser_users\".  This is a good idea \nto change if you want multiple installs of discloser \nin one database.\n"
read -p "Specify table name prefix: [discloser_] " tableprefix
if [[ $tableprefix = "" ]]; then tableprefix="discloser_"; fi

cat >../inc/vars.php<<zzendofcatzz
<?

/*
*  NAME
*	vars.php - Variables use throughout the site.  Human-edittable.
*
*/

// mysql host (usually localhost)
\$mysqlhost = "$sqlhost";

// mysql username
\$mysqluser = "$sqluser";

// mysql password
\$mysqlpass = "$sqlpass";

// mysql database name
\$mysqldb = "$sqldb";

// To specify a prefix for the table names
// (example "discloser_" would make the
// tables named discloser_users and discloser_posts
\$tableprefix = "$tableprefix";

\$use_bbcode = "no"; // yes or no
\$allow_html = "no"; // yes or no (only used if bbcode is not.)
\$print_date_once = "yes";  // yes or no
\$public_page_url = "/index.php"; // a convenience.  nothing serious will break if this is wrong.

// the contents of an "a href=" used to contact an admin.
\$administrative_contact = "mailto:webmaster@domain.com";

// uncomment below and set, if you need it
#\$session_file_storage_location = "/tmp";
	/*	this is a security measure to prevent session faking.. this only needs to be
		set if discloser is in a server environment where a malicious user can create
		a session for the same domain. (if this is in a public_html directory, not on
		a virtual host, where there may exist other users that cannot necessarily be
		trusted.)  It can also be used if the server is distributed, and doesn't share
		/tmp directories.  A common value would be "/home/user/tmp" where the webserver
		has read/write access. */


// will be depreciated before v.0.5
\$num_displayed_for_edit = "50";


?>
zzendofcatzz

echo "All done.  There are also upgrade scripts for making database (and possibly other) changes.  For example, if you previously used a version in the 0.0.3.x series, run upgrade_0.0.3-0.0.4.sh, which will make a change to the database tables without touching any of the data in them."
